"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var pickBy_1 = require("./pickBy");
var pipe_1 = require("./pipe");
describe('data first', function () {
    test('it should pick props', function () {
        var result = (0, pickBy_1.pickBy)({ a: 1, b: 2, A: 3, B: 4 }, function (val, key) { return key.toUpperCase() === key; });
        expect(result).toStrictEqual({ A: 3, B: 4 });
    });
    test('allow undefined or null', function () {
        expect((0, pickBy_1.pickBy)(undefined, function (val, key) { return key === 'foo'; })).toEqual({});
        expect((0, pickBy_1.pickBy)(null, function (val, key) { return key === 'foo'; })).toEqual({});
    });
});
describe('data last', function () {
    test('it should pick props', function () {
        var result = (0, pipe_1.pipe)({ a: 1, b: 2, A: 3, B: 4 }, (0, pickBy_1.pickBy)(function (val, key) { return key.toUpperCase() === key; }));
        expect(result).toEqual({ A: 3, B: 4 });
    });
});
