import { pickBy } from './pickBy';
import { pipe } from './pipe';
describe('data first', function () {
    test('it should pick props', function () {
        var result = pickBy({ a: 1, b: 2, A: 3, B: 4 }, function (val, key) { return key.toUpperCase() === key; });
        expect(result).toStrictEqual({ A: 3, B: 4 });
    });
    test('allow undefined or null', function () {
        expect(pickBy(undefined, function (val, key) { return key === 'foo'; })).toEqual({});
        expect(pickBy(null, function (val, key) { return key === 'foo'; })).toEqual({});
    });
});
describe('data last', function () {
    test('it should pick props', function () {
        var result = pipe({ a: 1, b: 2, A: 3, B: 4 }, pickBy(function (val, key) { return key.toUpperCase() === key; }));
        expect(result).toEqual({ A: 3, B: 4 });
    });
});
